// sort mafs by start position in first component

#define VERSION 1
#include "lib.h"
#include "maf.h"

static int compar(struct mafAli **a, struct mafAli **b) {
	int s1 = (**a).components->start, s2 = (**b).components->start;
	if (s1 > s2)
		return 1;
	if (s1 < s2)
		return -1;
	return 0;
}

int main(int argc, char **argv) {
	struct mafFile *mf;
	struct mafAli *a, **A;
	int i, n;
	char cmd[100];

	sprintf(cmd, "mafSort.v%d", VERSION);
	argv0 = cmd;
	if (argc != 2)
		fatal("arg = maf-file");

	mafWriteStart(stdout, cmd);
	printf("# %s %s\n", cmd, argv[1]);
	mf = mafReadAll(argv[1], 1);
	for (n = 0, a = mf->alignments; a != NULL; a = a->next)
		++n;
	A = ckalloc(n*sizeof(struct mafAli *));
	for (i = 0, a = mf->alignments; i < n && a != NULL; a = a->next, ++i)
		A[i] = a;
	if (i != n || a != NULL)
		fatal("cannot happen");
	qsort((void *) A, (size_t)n, sizeof(struct mafAli *),
	  (const void *)compar);
	for (i = 0; i < n; ++i)
		mafWrite(stdout, A[i]);
	return 0;
}
